#include <cstdint>

namespace hilbert::kernel::syscall {

  typedef void (*syscall_handler)(
    uint64_t &rax, uint64_t &rdi, uint64_t &rsi, uint64_t &rdx);

  void init_syscalls();

  //assumes this rax has not been used yet and is < 256.
  void add_syscall(uint64_t rax, syscall_handler handler);

}
